
require 'recls'
require 'synsoft/srcutil'

EXCLUDED_ROOTS 	= 	%w{ ace asm sys }

EXCLUDED_NAMES	=	%w{ stlsoft_cc_obsolete stlsoft__undefs stlsoft_cccap_unknown stlsoft_cccap_borland stlsoft_cccap_como stlsoft_cccap_dmc stlsoft_cccap_gcc stlsoft_cccap_intel stlsoft_cccap_msvc stlsoft_cccap_mwerks stlsoft_cccap_vectorc stlsoft_cccap_watcom }

rootDir	=	"."
pattern	=	"*.h;*.hpp"

fs = Recls::FileSearch::new(rootDir, pattern, Recls::FILES | Recls::RECURSIVE)

deps	=	{}

numFiles		=	0
numProcessed	=	0

class Line

		def initialize(line, guard = nil, before = nil, after = nil)
				@line	=	line
				@guard	=	guard
				@before	=	before
				@after	=	after
		end

		attr_reader :line, :guard, :before, :after
end

fs.each \
{ |fe|

#		puts "#{fe.path}"

		numFiles	=	1	+	numFiles

		lines = IO::readlines(fe.path)

		newLines	=	[]
		bChanged	=	0
		
		lines.each_with_index \
		{ |line, i|

				line = line.chomp
				
				lineNum	=	1 + i

				newLines.push(Line::new(line))

				# We'll check .hpp files first
				
				if line =~ /^(\s*#\s*include\s*[<|"])([a-z]+)\/([\w\/]+)\.hpp(.*)$/	# <project/name.hpp>
#						puts "#{fe.path}(#{i + 1}): #{$2} - #{$3}"
#puts "line: #{line}"
						projectDir	=	$2
						if EXCLUDED_ROOTS.include?(projectDir)
								next
						end
						mainProject	=	projectDir.upcase
#puts "projectDir: #{projectDir}"
						headerName	=	$3
#puts "headerName: #{headerName}"
#						headerName.gsub!(/\//, '_')
						subProjects	=	headerName.split('/')
#puts "subProjects: #{subProjects}"
						proj		=	projectDir.upcase
#puts "proj: #{proj}"
						subProj		=	proj
						subProjects[0 ... subProjects.length - 1].each { |pr| proj = proj + "_" + pr.upcase }
						headerName	=	subProjects[-1]
#puts "headerName: #{headerName}"
#subProjects[0 ... subProjects.length - 1].each_with_index { |pr, j| puts "#{j}: #{pr}" }
#puts "proj: #{proj}"
						nameU		=	headerName.upcase
						guard		=	mainProject + "_INCL_" + proj + "_HPP_" + nameU
#puts "guard: #{guard}"
#next
						if i > 0
								#
								before	=	lines[i - 1]
								after	=	lines[i + 1]

								if not before =~ /_INCL_/
										abort "#{fe.path}(#{lineNum - 1}): unguarded include"
								elsif not after =~ /_INCL_/
										abort "#{fe.path}(#{lineNum + 1}): unguarded include"
								else
										if not before =~ /^(\s*#\s*ifndef\s+)([\w\/]+)(.*)$/
												abort "#{fe.path}(#{lineNum - 1}): missing/invalid include guard"
										elsif not after =~ /^(\s*#\s*endif\s+\/\*\s*\!)([\w\/]+)(\s*\*\/.*)$/
												abort "#{fe.path}(#{lineNum + 1}): missing/invalid include guard: "
										else
												# Now check whether it's the right one

#												puts guard
												before =~ /^(\s*#\s*ifndef\s+)([\w\/]+)(.*)$/
												beforeGuard	=	$2
												beforePre	=	$1
												beforePost	=	$3
												after =~ /^(\s*#\s*endif\s+\/\*\s*\!)([\w\/]+)(\s*\*\/.*)$/
												afterGuard	=	$2
												afterPre	=	$1
												afterPost	=	$3
#puts "guard: #{guard}"
#puts "before: #{before}"
#puts "after: #{after}"
#exit if guard =~ /\//
#exit

												if beforeGuard != afterGuard
														abort "Before: #{beforeGuard}; after: #{afterGuard}"
												end
												if beforeGuard != guard
														newLines[-1] = Line::new(line, guard, beforePre + guard + beforePost, afterPre + guard + afterPost)
														bChanged = 1
												end
												
										end
								end
						else
								#
						end
				elsif line =~ /^(\s*#\s*include\s*[<|"])([a-z]+)\/([\w\/]+)\.h(.*)$/	# <project/name.h>
						projectDir	=	$2
						if EXCLUDED_ROOTS.include?(projectDir)
								next
						end
#						puts "#{fe.path}(#{i + 1}): #{$2} - #{$3}"
#puts "line: #{line}"
						mainProject	=	projectDir.upcase
#puts "projectDir: #{projectDir}"
						headerName	=	$3
#puts "headerName: #{headerName}"
#						headerName.gsub!(/\//, '_')
						subProjects	=	headerName.split('/')
#puts "subProjects: #{subProjects}"
						proj		=	projectDir.upcase
#puts "proj: #{proj}"
						subProj		=	proj
						subProjects[0 ... subProjects.length - 1].each { |pr| proj = proj + "_" + pr.upcase }
						headerName	=	subProjects[-1]
#puts "headerName: #{headerName}"
#subProjects[0 ... subProjects.length - 1].each_with_index { |pr, j| puts "#{j}: #{pr}" }
#puts "proj: #{proj}"
						nameU		=	headerName.upcase
						guard		=	mainProject + "_INCL_" + proj + "_H_" + nameU
#puts "guard: #{guard}"
						if i > 0
								#
								before	=	lines[i - 1]
								after	=	lines[i + 1]

								if not before =~ /_INCL_/
										abort "#{fe.path}(#{lineNum - 1}): unguarded include"
								elsif not after =~ /_INCL_/
										abort "#{fe.path}(#{lineNum + 1}): unguarded include"
								else
										if not before =~ /^(\s*#\s*ifndef\s+)([\w\/]+)(.*)$/
												abort "#{fe.path}(#{lineNum - 1}): missing/invalid include guard"
										elsif not after =~ /^(\s*#\s*endif\s+\/\*\s*\!)([\w\/]+)(\s*\*\/.*)$/
												abort "#{fe.path}(#{lineNum + 1}): missing/invalid include guard: "
										else
												# Now check whether it's the right one

#												puts guard
												before =~ /^(\s*#\s*ifndef\s+)([\w\/]+)(.*)$/
												beforeGuard	=	$2
												beforePre	=	$1
												beforePost	=	$3
												after =~ /^(\s*#\s*endif\s+\/\*\s*\!)([\w\/]+)(\s*\*\/.*)$/
												afterGuard	=	$2
												afterPre	=	$1
												afterPost	=	$3
#puts "guard: #{guard}"
#puts "before: #{before}"
#puts "after: #{after}"
#exit if guard =~ /\//
#exit

												if beforeGuard != afterGuard
														abort "#{fe.path}(#{lineNum}): Mismatched before/after guards; Before: #{beforeGuard}; after: #{afterGuard}"
												end
												if beforeGuard != guard
														newLines[-1] = Line::new(line, guard, beforePre + guard + beforePost, afterPre + guard + afterPost)
														bChanged = 1
												end
												
										end
								end
						else
								#
						end
				elsif line =~ /^(\s*#\s*include\s*[<|"])([a-z]+)_(\w+)\.h(.*)$/	# <project_name.h>
						projectDir	=	$2
						headerName	=	$3
						fileName	=	projectDir + "_" + headerName
						if EXCLUDED_ROOTS.include?(projectDir)
								next
						end
						if EXCLUDED_NAMES.include?(fileName)
								next
						end
#						puts "#{fe.path}(#{i + 1}): #{$2} - #{$3}"
#puts "line: #{line}"
						mainProject	=	projectDir.upcase
#puts "projectDir: #{projectDir}"
#puts "headerName: #{headerName}"
#puts "fileName: #{fileName}"
#						headerName.gsub!(/\//, '_')
						subProjects	=	headerName.split('/')
#puts "subProjects: #{subProjects}"
						proj		=	projectDir.upcase
#puts "proj: #{proj}"
						subProj		=	proj
						subProjects[0 ... subProjects.length - 1].each { |pr| proj = proj + "_" + pr.upcase }
						headerName	=	subProjects[-1]
#puts "headerName: #{headerName}"
#subProjects[0 ... subProjects.length - 1].each_with_index { |pr, j| puts "#{j}: #{pr}" }
#puts "proj: #{proj}"
						nameU		=	headerName.upcase
						guard		=	mainProject + "_INCL_" + "H_" + fileName.upcase
#puts "guard: #{guard}"
#exit
#next
						if i > 0
								#
								before	=	lines[i - 1]
								after	=	lines[i + 1]

								if not before =~ /_INCL_/
										abort "#{fe.path}(#{lineNum - 1}): unguarded include"
								elsif not after =~ /_INCL_/
										abort "#{fe.path}(#{lineNum + 1}): unguarded include"
								else
										if not before =~ /^(\s*#\s*ifndef\s+)([\w\/]+)(.*)$/
												abort "#{fe.path}(#{lineNum - 1}): missing/invalid include guard"
										elsif not after =~ /^(\s*#\s*endif\s+\/\*\s*\!)([\w\/]+)(\s*\*\/.*)$/
												abort "#{fe.path}(#{lineNum + 1}): missing/invalid include guard: "
										else
												# Now check whether it's the right one

#												puts guard
												before =~ /^(\s*#\s*ifndef\s+)([\w\/]+)(.*)$/
												beforeGuard	=	$2
												beforePre	=	$1
												beforePost	=	$3
												after =~ /^(\s*#\s*endif\s+\/\*\s*\!)([\w\/]+)(\s*\*\/.*)$/
												afterGuard	=	$2
												afterPre	=	$1
												afterPost	=	$3

												if beforeGuard != afterGuard
														abort "Before: #{beforeGuard}; after: #{afterGuard}"
												end
												if beforeGuard != guard
abort "BeforeGuard: #{beforeGuard}; guard: #{guard}"
puts "guard: #{guard}"
puts "before: #{before}"
puts "after: #{after}"
exit if guard =~ /\//
exit
														newLines[-1] = Line::new(line, guard, beforePre + guard + beforePost, afterPre + guard + afterPost)
														bChanged = 1
												end
												
										end
								end
						else
								#
						end
				end
		}

		if bChanged > 0
				newLines.each_with_index \
				{ |nl, i|
						if nl.guard
#								puts "Before: '#{newLines[i - 1].line}' => '#{nl.before}'"
								newLines[i - 1] = Line::new(nl.before)
#								puts "After:  '#{newLines[i + 1].line}' => '#{nl.after}'"
								newLines[i + 1] = Line::new(nl.after)
						end
				}

				if not File::writable?(fe.path)
						puts "#{fe.path} is not writable"
				else
						puts "#{fe.path}"
						begin
#								newLines.each { |nl| puts nl.line << "\n" }
								
#								newLines = SrcUtil::updateMinor(newLines, true)
								f = File::new(fe.path, "w")
								newLines.each { |nl| f << nl.line << "\n" }
								f.close()
								numProcessed	=	1 + numProcessed
						rescue StandardError => x
								puts "Error processing #{fe.path}: " + String(x)
						end
				end
		end
}

puts "  Processed #{numProcessed} of #{numFiles} file(s)"

