
require 'recls'

rootDir	=	"./inprogress"
pattern	=	"*.hpp;*.h"

fs = Recls::FileSearch::new(rootDir, pattern, Recls::FILES | Recls::RECURSIVE)

fs.each \
{ |fe|

	lines = IO::readlines(fe.path)

	if lines.length < 1
		puts "#{fe.path} is empty"
		next
	elsif lines.length < 3
		line0 = lines[0].chomp
		if lines.length == 2
			line1 = lines[1].chomp
		else
			line1 = ""
		end

		if line1.length > 0
			puts "#{fe.path} second line is not empty!"
			next
		else
			if line0 =~ /^#include \<(\w+?)_(\w+)\.h\>.*$/
					project	=	$1.upcase
					name	=	$2.upcase
					incl	=	"# include <#{$1}_#{$2}.h>"
					shimSymbol 	= 	"#{project}_INCL_#{project}_#{fe.fileExt.upcase}_#{name}"
					inclSymbol 	= 	"#{project}_INCL_H_#{project}_#{name}"
					f = File::new(fe.path, "w")
					f << "#ifndef #{shimSymbol}" << "\n"
					f << "#define #{shimSymbol}" << "\n"
					f << "\n"
					f << "#ifndef #{inclSymbol}" << "\n"
					f << "#{incl}" << "\n"
					f << "#endif /* !#{inclSymbol} */" << "\n"
					f << "\n"
					f << "#endif /* !#{shimSymbol} */" << "\n"
					f.close()
					puts "#{fe.path}: processed"
			else
				puts "#{fe.path}(0): Unrecognised: #{line0}"
			end
		end
	end
}

